
format PE GUI 4.0
entry start

include 'c:\Users\hapr-lera\Documents\Assembler\FasmEx\INCLUDE\win32ax.inc'
PHYSICAL_MONITOR_DESCRIPTION_SIZE  =  128
MONITOR_DEFAULTTONULL              =  0x00000000
MONITOR_DEFAULTTOPRIMARY           =  0x00000001
MONITOR_DEFAULTTONEAREST           =  0x00000002

;----------------------------
struct PHYSICAL_MONITOR
 hPhysicalMonitor                dd  ?
 szPhysicalMonitorDescription    dw PHYSICAL_MONITOR_DESCRIPTION_SIZE dup(?)
ends


section '.text' code readable executable

  start:
  ;        
  invoke  GetDesktopWindow
     mov  ebp,eax

  ;  ""    
  invoke  MonitorFromWindow,ebp,MONITOR_DEFAULTTONEAREST
     mov  ebp,eax

  ;       -          = 1
  invoke  GetNumberOfPhysicalMonitorsFromHMONITOR,ebp,NumberOfPhysicalMonitors

  ; 
  invoke  GetPhysicalMonitorsFromHMONITOR,ebp,[NumberOfPhysicalMonitors],aPhysicalMonitorArray

     ;   
     mov  ebx,[aPhysicalMonitorArray.hPhysicalMonitor]

  ; 
  invoke  SetVCPFeature,ebx,0xD6,4

  ;          
  invoke  Sleep,10000

  ; 
  invoke  SetVCPFeature,ebx,0xD6,1

  ;
  invoke  DestroyPhysicalMonitors,[NumberOfPhysicalMonitors],aPhysicalMonitorArray

  invoke  ExitProcess,0

section '.data' data readable writeable

 NumberOfPhysicalMonitors   dd  ?

 aPhysicalMonitorArray        PHYSICAL_MONITOR
                              db  sizeof.PHYSICAL_MONITOR*5 dup(?);         5 

section '.idata' import data readable writeable



  library kernel,'Kernel32.dll',\
          User32,'User32.dll',\
          Dxva2,'Dxva2.dll'



  import kernel,\
         ExitProcess,'ExitProcess',\
         Sleep,'Sleep'

 import User32,\
        MonitorFromWindow,'MonitorFromWindow',\
        GetDesktopWindow,'GetDesktopWindow'


 import Dxva2,\
        DestroyPhysicalMonitors,'DestroyPhysicalMonitors',\
        GetPhysicalMonitorsFromHMONITOR,'GetPhysicalMonitorsFromHMONITOR',\
        GetNumberOfPhysicalMonitorsFromHMONITOR,'GetNumberOfPhysicalMonitorsFromHMONITOR',\
        GetCapabilitiesStringLength,'GetCapabilitiesStringLength',\
        GetVCPFeatureAndVCPFeatureReply,'GetVCPFeatureAndVCPFeatureReply',\
        CapabilitiesRequestAndCapabilitiesReply,'CapabilitiesRequestAndCapabilitiesReply',\
        GetMonitorTechnologyType,'GetMonitorTechnologyType',\
        SetVCPFeature,'SetVCPFeature'
